
***************************************************************************************************
* PROGRAMA:	Run Horse
* LENGUAJE:     HMG
* FECHA:	JUNIO 2010
* AUTOR:	Dr. CLAUDIO SOTO
* PAIS:		URUGUAY
* E-MAIL:	srvet@adinet.com.uy
***************************************************************************************************


#include "minigui.ch" 
#include "..\BITMAP_ext.CH"

Function Main 

     
#define SPRITE_hBITMAP 1
#define SPRITE_NRO     2
#define SPRITE_X       3
#define SPRITE_Y       4
#define SPRITE_Z       5
#define SPRITE_WIDTH   6
#define SPRITE_HEIGHT  7    
#define SPRITE_TRANSP  8


PRIVATE hWND := 0
PRIVATE Anim_Pict := {}
PRIVATE Horse1 := {}
PRIVATE Horse2 := {}
PRIVATE Horse3 := {}
PRIVATE Eagle  := {}
PRIVATE Jinete := {}

PRIVATE TextIntro_hBITMAP := 0
PRIVATE Pictures_hBITMAP := 0
PRIVATE Background_hBITMAP := 0
PRIVATE Background_WIDTH := 0
PRIVATE Background_HEIGHT := 0
PRIVATE Memory_Buffer_hBITMAP := {}
PRIVATE Intro1_hBITMAP := 0
PRIVATE Intro2_hBITMAP := 0
PRIVATE End_hBITMAP    := 0
PRIVATE Uruguay_hBITMAP := 0

PRIVATE TV_FILE         := "TV.bmp"
PRIVATE Intro1_FILE     := "Intro1.bmp"
PRIVATE Intro2_FILE     := "Intro2.bmp"
PRIVATE Background_FILE := "Fondo.bmp"
PRIVATE Pictures_FILE1  := "Horse_Sprite.bmp"
PRIVATE Pictures_FILE2  := "Caballo.bmp"
PRIVATE Pictures_FILE3  := "Jinete.bmp"
PRIVATE Pictures_FILE4  := "Aguila.bmp"
PRIVATE Pictures_FILE5  := "Uruguay.bmp"

PRIVATE Sound_FILE      := "Horse.mp3"

PRIVATE Black_and_White := .F.
PRIVATE k1, k2, k3, k4, k5, j, pos_x1, pos_x2, pos_x3, pos_x4, pos_x5
PRIVATE Flag_Run   := .F.
PRIVATE Flag_Intro := .T.

* TV Size
#define TV_WIDTH 600
#define TV_HEIGHT 403


* SCREEN ANIM Size
#define TV_X1 42
#define TV_Y1 28
#define TV_X2 559
#define TV_Y2 320

PRIVATE SCR_WIDTH  := TV_X2 - TV_X1
PRIVATE SCR_HEIGHT := TV_Y2 - TV_Y1


    DEFINE WINDOW Form_1; 
        AT 0,0; 
        WIDTH 605; 
        HEIGHT 550; 
        TITLE 'Run Horse';
        NOMAXIMIZE;
        NOSIZE; 
        MAIN;
        ON RELEASE Release_Handle ()   
        
                
        @ 0,0 IMAGE Image_1 PICTURE TV_FILE WIDTH TV_WIDTH HEIGHT TV_HEIGHT 
           
        @ TV_Y1, TV_X1 IMAGE Image_2 PICTURE "" WIDTH 0 HEIGHT 0 ACTION CLICK_SPRITE ()
  
        @ 0,0 PLAYER Sound_1 WIDTH 0 HEIGHT 0 FILE "" NOAUTOSIZEWINDOW NOAUTOSIZEMOVIE NOERRORDLG NOMENU NOPLAYBAR NOOPEN 
  

        @ 410,  50 BUTTON Boton_00 CAPTION "B/W Center" ACTION {|| Black_and_White := .NOT. (Black_and_White)}
        
        @ 450,  50 BUTTON Boton_1 CAPTION "Begin"    ACTION PLAY_ANIM ()
        @ 450, 200 BUTTON Boton_2 CAPTION "Pause"    ACTION PAUSE_ANIM ()
        @ 450, 350 BUTTON Boton_3 CAPTION "Finalize" ACTION {|| ANIM_END(), STOP_ANIM ()}
         
        @ 410, 250 LABEL Label_1 VALUE "Click in the Pictures" FONT "Arial" SIZE 10 BOLD FONTCOLOR RED AUTOSIZE
         
        Form_1.Boton_00.Enabled := .F. 
        Form_1.Boton_2.Enabled := .F.         
        Form_1.Boton_3.Enabled := .F.
         
        Form_1.Label_1.Visible := .F.
                
        CREATE_ANIM ()
            
    END WINDOW 

    CENTER WINDOW Form_1

    ACTIVATE WINDOW Form_1
        
Return



**************************************************************************************************************
Procedure PAUSE_ANIM 
    Form_1.Timer_1.Enabled := .F.
    
    Form_1.Boton_00.Enabled := .F.    
    Form_1.Boton_1.Enabled := .T.
    Form_1.Boton_2.Enabled := .F.
    Form_1.Boton_3.Enabled := .T.
    
    Form_1.Boton_1.Caption := "Resume"
    Flag_Intro := .F.
Return



**************************************************************************************************************
Procedure STOP_ANIM
 
    Form_1.Timer_1.Enabled := .F.
    
    Form_1.Boton_00.Enabled := .F.
    Form_1.Boton_2.Enabled := .F.
    Form_1.Boton_3.Enabled := .F.
    
    Form_1.Label_1.Visible := .F.
        
    Flag_Run   := .F.
    Flag_Intro := .T.
    
    RELEASE_HANDLE ()
    BMP_RELEASE (Memory_Buffer_hBITMAP)
    CREATE_ANIM ()
    
    Form_1.Boton_1.Enabled := .T.
    Form_1.Boton_1.Caption := "Begin"
Return



**************************************************************************************************************
Procedure RELEASE_HANDLE 
    
    FOR i = 1 TO LEN (Horse1)
        BMP_RELEASE (Horse1 [i, SPRITE_hBITMAP])        
    NEXT
    
    FOR i = 1 TO LEN (Horse2)
        BMP_RELEASE (Horse2 [i, SPRITE_hBITMAP])        
    NEXT
    
    FOR i = 1 TO LEN (Horse3)
        BMP_RELEASE (Horse3 [i, SPRITE_hBITMAP])        
    NEXT

    FOR i = 1 TO LEN (Jinete)
        BMP_RELEASE (Jinete [i, SPRITE_hBITMAP])        
    NEXT

    FOR i = 1 TO LEN (Eagle)
        BMP_RELEASE (Eagle [i, SPRITE_hBITMAP])        
    NEXT

    BMP_RELEASE (Intro1_hBITMAP)
    BMP_RELEASE (Intro2_hBITMAP)
    BMP_RELEASE (End_hBITMAP)
    BMP_RELEASE (Background_hBITMAP)
    BMP_RELEASE (TextIntro_hBITMAP)
    BMP_RELEASE (Uruguay_hBITMAP)
    *BMP_RELEASE (Memory_Buffer_hBITMAP) // No es necesario liberar este handle aqui, es liberado por el Control IMAGE de HMG
                                         // al cerrar la ventana Form_1 con ON RELEASE
    
Return



**************************************************************************************************************
Procedure CREATE_ANIM
   
   Memory_Buffer_hBITMAP := BMP_CREATE (SCR_WIDTH, SCR_HEIGHT)
   
   Intro1_hBITMAP_old := BMP_LOAD_FILE (Intro1_FILE)
   Intro2_hBITMAP := BMP_LOAD_FILE (Intro2_FILE)
   TextIntro_hBITMAP := BMP_CREATE (SCR_WIDTH, SCR_HEIGHT)
      

  
   Intro1_hBITMAP := BMP_RESIZE (Intro1_hBITMAP_old, SCR_WIDTH, SCR_HEIGHT, BMP_STRETCH)
   BMP_RELEASE (Intro1_hBITMAP_old)

   BMP_TEXTOUT (TextIntro_hBITMAP, 258, 50, "HMG Pictures", "Times New Roman", 32, ArrayRGB_TO_COLORREF(BLUE),;
             ArrayRGB_TO_COLORREF(RED), BMP_TEXTOUT_TRANSPARENT, BMP_TEXTOUT_CENTER)
   
   BMP_TEXTOUT (TextIntro_hBITMAP, 258, 100, "Present", "Times New Roman", 28, ArrayRGB_TO_COLORREF(BLUE),;
             ArrayRGB_TO_COLORREF(RED), BMP_TEXTOUT_TRANSPARENT, BMP_TEXTOUT_CENTER)             
   
*   BMP_TEXTOUT (TextIntro_hBITMAP, 258, 150, "Run Horse", "Times New Roman", 28, ArrayRGB_TO_COLORREF(BLUE),;
*             ArrayRGB_TO_COLORREF(RED), BMP_TEXTOUT_TRANSPARENT, BMP_TEXTOUT_CENTER)             

    
   Background_hBITMAP := BMP_LOAD_FILE (Background_FILE)
   Background_WIDTH   := BMP_GET_INFO  (Background_hBITMAP, BMP_INFO_WIDTH)
   Background_HEIGHT  := BMP_GET_INFO  (Background_hBITMAP, BMP_INFO_HEIGHT)

   
   Pictures_hBITMAP   := BMP_LOAD_FILE (Pictures_FILE1) //"Horse_sprite.bmp"

   #define NRO_PICT_HORIZ 4
   #define NRO_PICT_VERT  3   
   
   #define SPT_WIDTH 125
   #define SPT_HEIGHT 100

   k = 0
   Horse1 := {}
   FOR i = NRO_PICT_VERT TO NRO_PICT_VERT
       FOR j = 1 TO NRO_PICT_HORIZ
           y = (i - 1) * SPT_HEIGHT
           x = (j - 1) * SPT_WIDTH
           aadd (Horse1,{0,0,0,0,0,0,0,0})
           k++            
           Horse1 [k, SPRITE_hBITMAP]:= BMP_GET_SPRITE (Pictures_hBITMAP, x, y, SPT_WIDTH, SPT_HEIGHT)           
           Horse1 [k, SPRITE_NRO]    := 100 + k
           Horse1 [k, SPRITE_X]      := 120
           Horse1 [k, SPRITE_Y]      := 200
           Horse1 [k, SPRITE_Z]      := 25
           Horse1 [k, SPRITE_WIDTH]  := BMP_GET_INFO  (Horse1 [k, SPRITE_hBITMAP], BMP_INFO_WIDTH)
           Horse1 [k, SPRITE_HEIGHT] := BMP_GET_INFO  (Horse1 [k, SPRITE_hBITMAP], BMP_INFO_HEIGHT)
           Horse1 [k, SPRITE_TRANSP] := BMP_GET_PIXEL (Horse1 [k, SPRITE_hBITMAP], 0, 0)
           
           BMP_CHANGUE_COLOR (Horse1 [k, SPRITE_hBITMAP], 0, 0, Horse1 [k, SPRITE_WIDTH], Horse1 [k, SPRITE_HEIGHT], ArrayRGB_TO_COLORREF (BLACK), RGB (60,60,60))
        
       NEXT
   NEXT        
   
   k = 0
   Horse2 := {}
   FOR i = 3 TO 3
       FOR j = 1 TO NRO_PICT_HORIZ
           y = (i - 1) * SPT_HEIGHT
           x = (j - 1) * SPT_WIDTH
           aadd (Horse2,{0,0,0,0,0,0,0,0})
           k++ 
           
           Horse2 [k, SPRITE_hBITMAP]:= BMP_GET_SPRITE (Pictures_hBITMAP, x, y, SPT_WIDTH, SPT_HEIGHT)           
           Horse2 [k, SPRITE_NRO]    := 200 + k
           Horse2 [k, SPRITE_X]      := 200
           Horse2 [k, SPRITE_Y]      := 200
           Horse2 [k, SPRITE_Z]      := 50
           Horse2 [k, SPRITE_WIDTH]  := BMP_GET_INFO  (Horse2 [k, SPRITE_hBITMAP], BMP_INFO_WIDTH)
           Horse2 [k, SPRITE_HEIGHT] := BMP_GET_INFO  (Horse2 [k, SPRITE_hBITMAP], BMP_INFO_HEIGHT)
           Horse2 [k, SPRITE_TRANSP] := BMP_GET_PIXEL (Horse2 [k, SPRITE_hBITMAP], 0, 0)
           
       NEXT
   NEXT        
   
   BMP_RELEASE (Pictures_hBITMAP)
   
   
   Pictures_hBITMAP   := BMP_LOAD_FILE (Pictures_FILE2) // "Caballo.bmp"
   Nro_Pict_Horiz = 1
   Nro_Pict_Vert  = 6
   
   Pict_Width  = INT (BMP_GET_INFO  (Pictures_hBITMAP, BMP_INFO_WIDTH)  / Nro_Pict_Horiz)    
   Pict_Height = INT (BMP_GET_INFO  (Pictures_hBITMAP, BMP_INFO_HEIGHT) / Nro_Pict_Vert)
   
   
   Horse3 := {}
   k = 0
   FOR i = 1 TO Nro_Pict_Vert     
       FOR j = 1 TO Nro_Pict_Horiz
           
           x = (j - 1) * Pict_Width
           y = (i - 1) * Pict_Height          

           aadd (Horse3,{0,0,0,0,0,0,0,0})
           k++ 
           
           Horse3 [k, SPRITE_hBITMAP]:= BMP_GET_SPRITE (Pictures_hBITMAP, x, y, Pict_Width, Pict_Height)            
           Horse3 [k, SPRITE_NRO]    := 300 + k
           Horse3 [k, SPRITE_X]      := 190
           Horse3 [k, SPRITE_Y]      := 190
           Horse3 [k, SPRITE_Z]      := 75
           Horse3 [k, SPRITE_WIDTH]  := BMP_GET_INFO  (Horse3 [k, SPRITE_hBITMAP], BMP_INFO_WIDTH)
           Horse3 [k, SPRITE_HEIGHT] := BMP_GET_INFO  (Horse3 [k, SPRITE_hBITMAP], BMP_INFO_HEIGHT)
           Horse3 [k, SPRITE_TRANSP] := BMP_GET_PIXEL (Horse3 [k, SPRITE_hBITMAP], 0, 0)
       NEXT
   NEXT        
   BMP_RELEASE (Pictures_hBITMAP)
   

   aux_hBITMAP   := BMP_LOAD_FILE (Pictures_FILE3) //"Jinete.bmp"   
   Pictures_hBITMAP := BMP_RESIZE (aux_hBITMAP,; 
                                   INT (BMP_GET_INFO (aux_hBITMAP, BMP_INFO_WIDTH) * 0.5),;
                                   INT (BMP_GET_INFO (aux_hBITMAP, BMP_INFO_HEIGHT)* 0.5),; 
                                   BMP_SCALE)   
   BMP_RELEASE (aux_hBITMAP)

      
   Nro_Pict_Horiz = 1
   Nro_Pict_Vert  = 5
   
   Pict_Width  = INT (BMP_GET_INFO  (Pictures_hBITMAP, BMP_INFO_WIDTH)  / Nro_Pict_Horiz)    
   Pict_Height = INT (BMP_GET_INFO  (Pictures_hBITMAP, BMP_INFO_HEIGHT) / Nro_Pict_Vert)
   
   
   Jinete := {}
   k = 0
   FOR i = 1 TO Nro_Pict_Vert     
       FOR j = 1 TO Nro_Pict_Horiz
           
           x = (j - 1) * Pict_Width
           y = (i - 1) * Pict_Height          

           aadd (Jinete,{0,0,0,0,0,0,0,0})
           k++ 
           
           Jinete [k, SPRITE_hBITMAP]:= BMP_GET_SPRITE (Pictures_hBITMAP, x, y, Pict_Width, Pict_Height)            
           Jinete [k, SPRITE_NRO]    := 400 + k
           Jinete [k, SPRITE_X]      := 200
           Jinete [k, SPRITE_Y]      := 180
           Jinete [k, SPRITE_Z]      := 0
           Jinete [k, SPRITE_WIDTH]  := BMP_GET_INFO  (Jinete [k, SPRITE_hBITMAP], BMP_INFO_WIDTH) 
           Jinete [k, SPRITE_HEIGHT] := BMP_GET_INFO  (Jinete [k, SPRITE_hBITMAP], BMP_INFO_HEIGHT)
           Jinete [k, SPRITE_TRANSP] := BMP_GET_PIXEL (Jinete [k, SPRITE_hBITMAP], 0, 0)                      
       NEXT
   NEXT        
   BMP_RELEASE (Pictures_hBITMAP)




   aux_hBITMAP   := BMP_LOAD_FILE (Pictures_FILE4)  //"Aguila2.bmp"

   Pictures_hBITMAP := BMP_RESIZE (aux_hBITMAP,; 
                                   INT (BMP_GET_INFO (aux_hBITMAP, BMP_INFO_WIDTH) * 0.50),;
                                   INT (BMP_GET_INFO (aux_hBITMAP, BMP_INFO_HEIGHT)* 0.50),; 
                                   BMP_SCALE)   
   BMP_RELEASE (aux_hBITMAP)

   Nro_Pict_Horiz = 1
   Nro_Pict_Vert  = 30
   
   Pict_Width  = INT (BMP_GET_INFO  (Pictures_hBITMAP, BMP_INFO_WIDTH)  / Nro_Pict_Horiz)    
   Pict_Height = INT (BMP_GET_INFO  (Pictures_hBITMAP, BMP_INFO_HEIGHT) / Nro_Pict_Vert)
   
   
   Eagle := {}
   k = 0
   FOR i = 1 TO Nro_Pict_Vert     
       FOR j = 1 TO Nro_Pict_Horiz
           
           x = (j - 1) * Pict_Width
           y = (i - 1) * Pict_Height          

           aadd (Eagle,{0,0,0,0,0,0,0,0})
           k++ 
           
           Eagle [k, SPRITE_hBITMAP]:= BMP_GET_SPRITE (Pictures_hBITMAP, x, y, Pict_Width, Pict_Height)            
           Eagle [k, SPRITE_NRO]    := 500 + k
           Eagle [k, SPRITE_X]      := 200
           Eagle [k, SPRITE_Y]      := 20
           Eagle [k, SPRITE_Z]      := 0
           Eagle [k, SPRITE_WIDTH]  := BMP_GET_INFO  (Eagle [k, SPRITE_hBITMAP], BMP_INFO_WIDTH) 
           Eagle [k, SPRITE_HEIGHT] := BMP_GET_INFO  (Eagle [k, SPRITE_hBITMAP], BMP_INFO_HEIGHT)
           Eagle [k, SPRITE_TRANSP] := BMP_GET_PIXEL (Eagle [k, SPRITE_hBITMAP], 0, 0)           
       NEXT
   NEXT        
   BMP_RELEASE (Pictures_hBITMAP)

   
   Anim_Pict := {}
   aadd (Anim_Pict, Horse1 [1])
   aadd (Anim_Pict, Horse2 [1])
   aadd (Anim_Pict, Horse3 [1])
   aadd (Anim_Pict, Jinete [1])
   aadd (Anim_Pict, Eagle  [1])
   
   k1 := 1 
   k2 := 2 
   k3 := 3
   k4 := 1  
   k5 := 1
   j:= 0 
   Black_and_White = .F.
   pos_x1 := - Horse1 [1, SPRITE_WIDTH]
   pos_x2 := - Horse2 [1, SPRITE_WIDTH]
   pos_x3 := - Horse3 [1, SPRITE_WIDTH]
   pos_x4 := - Jinete [1, SPRITE_WIDTH]
   pos_x5 :=   Eagle  [1, SPRITE_WIDTH] + SCR_WIDTH
          
   hWND := IMAGE_GET_hWND  ("Form_1","Image_2") 
   
   BMP_CHANGUE_COLOR (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, RGB(0,0,0), ArrayRGB_TO_COLORREF (GRAY))
   
   IMAGE_SET_hBITMAP  ("Form_1", "Image_2", Memory_Buffer_hBITMAP, BMP_GET_INFO (Memory_Buffer_hBITMAP, BMP_INFO_WIDTH), BMP_GET_INFO (Memory_Buffer_hBITMAP, BMP_INFO_HEIGHT))
             
Return



******************************************************************************************************************
Procedure PLAY_ANIM
      
   Form_1.Boton_1.Enabled := .F.
   
   IF Flag_Intro = .T.
      Form_1.Boton_1.Caption := "Begin"
      ANIM_INTRO ()
   ENDIF
   
   Form_1.Boton_1.Caption := "Resume"     
        
   Flag_Run := .T.
   Form_1.Boton_00.Enabled := .T.
                                                                                              
   IF IsControlDefined (Timer_1, Form_1) = .F. 
      DEFINE TIMER Timer_1 OF Form_1 INTERVAL 100 ACTION RUN_HORSE ()
   ELSE
      Form_1.Timer_1.Enabled := .T.   
   ENDIF 
   
   Form_1.Boton_2.Enabled := .T.
   Form_1.Boton_3.Enabled := .T.
  
   Form_1.Label_1.Visible := .T.

Return


******************************************************************************************************************
Procedure ANIM_INTRO

      Form_1.Sound_1.Open (Sound_FILE)                              
      Form_1.Sound_1.Play
      DO WHILE .NOT. (Form_1.Sound_1.Position > 1500)
      ENDDO
        
      FOR cont_intro = 0 TO 8        
          BMP_COPY_BITBLT (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, Intro1_hBITMAP, 0, 0)
          BMP_COPY_TRANSPARENTBLT (Memory_Buffer_hBITMAP, 220, 50,; 
                                   85, 83,; 
                                   Intro2_hBITMAP, 0, cont_intro*83,;
                                   85, 83,;
                                   ArrayRGB_TO_COLORREF (BLUE), BMP_STRETCH)
                    
          BMP_SHOW (hWND, 0, 0, SCR_WIDTH, SCR_HEIGHT, Memory_Buffer_hBITMAP, BMP_COPY)          
          SYS_DELAY_WITH_DOEVENTS (100)          
      NEXT
        
      SYS_DELAY_WITH_DOEVENTS (2000)            
      Form_1.Sound_1.Stop
      Form_1.Sound_1.Close
      
      BMP_CLEAN (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, ArrayRGB_TO_COLORREF (BLACK))                            
            
      FOR alpha = 1 TO 60
          BMP_COPY_ALPHABLEND (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, TextIntro_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, alpha, BMP_STRETCH)                                 
          BMP_SHOW (hWND, 0, 0, SCR_WIDTH, SCR_HEIGHT, Memory_Buffer_hBITMAP, BMP_COPY)
          SYS_DELAY_WITH_DOEVENTS (100)
      NEXT
                       
      FOR i = 5 TO 200 STEP 5
          BMP_TEXTOUT (Memory_Buffer_hBITMAP, 258, 150, "Run Horse", "Times New Roman", 28, RGB (i,0,0),;
          ArrayRGB_TO_COLORREF(GREEN), BMP_TEXTOUT_TRANSPARENT, BMP_TEXTOUT_CENTER)                     
          BMP_SHOW (hWND, 0, 0, SCR_WIDTH, SCR_HEIGHT, Memory_Buffer_hBITMAP, BMP_COPY)       
          SYS_DELAY_WITH_DOEVENTS (100)
      NEXT
             
      SYS_DELAY_WITH_DOEVENTS (300)
 
            
      FOR alpha = 1 TO 60
          BMP_COPY_ALPHABLEND (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, Background_hBITMAP, 0, 69, SCR_WIDTH, SCR_HEIGHT, alpha, BMP_STRETCH)                                 
          BMP_SHOW (hWND, 0, 0, SCR_WIDTH, SCR_HEIGHT, Memory_Buffer_hBITMAP, BMP_COPY)       
          SYS_DELAY_WITH_DOEVENTS (100)
      NEXT        
Return



*************************************************************************************************************
Procedure ANIM_END
      Form_1.Timer_1.Enabled := .F.
    
      Form_1.Boton_00.Enabled := .F.
      Form_1.Boton_1.Enabled := .F.
      Form_1.Boton_2.Enabled := .F.
      Form_1.Boton_3.Enabled := .F.
    
      Form_1.Label_1.Visible := .F.

      
      End_hBITMAP := BMP_CREATE (SCR_WIDTH, SCR_HEIGHT *2)
      
      BMP_TEXTOUT (End_hBITMAP, 258, 100, "THE END", "Times New Roman", 32, ArrayRGB_TO_COLORREF(BLUE),;
             ArrayRGB_TO_COLORREF(RED), BMP_TEXTOUT_TRANSPARENT, BMP_TEXTOUT_CENTER)             
     
      FOR alpha = 1 TO 60
          BMP_COPY_ALPHABLEND (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, End_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, alpha, BMP_STRETCH)                                 
          BMP_SHOW (hWND, 0, 0, SCR_WIDTH, SCR_HEIGHT, Memory_Buffer_hBITMAP, BMP_COPY)       
          SYS_DELAY_WITH_DOEVENTS (100)
      NEXT        
      
      SYS_DELAY_WITH_DOEVENTS (300)

      BMP_TEXTOUT (End_hBITMAP, 258, SCR_HEIGHT+30, "(c) Dr. Claudio Soto", "Times New Roman", 24, ArrayRGB_TO_COLORREF(BLUE),;
             ArrayRGB_TO_COLORREF(RED), BMP_TEXTOUT_TRANSPARENT, BMP_TEXTOUT_CENTER)

      BMP_TEXTOUT (End_hBITMAP, 258, SCR_HEIGHT+80, "Junio 2010, Uruguay", "Times New Roman", 20, ArrayRGB_TO_COLORREF(BLUE),;
             ArrayRGB_TO_COLORREF(RED), BMP_TEXTOUT_TRANSPARENT, BMP_TEXTOUT_CENTER)             
      
      Uruguay_hBITMAP := BMP_LOAD_FILE (Pictures_FILE5)
      
      BMP_PUT_SPRITE (End_hBITMAP, 240, SCR_HEIGHT+130, Uruguay_hBITMAP, 0, 0, 50, 50)
                    
      FOR i = 1 TO SCR_HEIGHT + 180
          *BMP_COPY_ALPHABLEND (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, End_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, alpha, BMP_STRETCH)                                 
          BMP_COPY_BITBLT (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, End_hBITMAP, 0, i)
          BMP_SHOW (hWND, 0, 0, SCR_WIDTH, SCR_HEIGHT, Memory_Buffer_hBITMAP, BMP_COPY)       
          SYS_DELAY_WITH_DOEVENTS (50)
      NEXT
 
Return
*************************************************************************************************************



Procedure RUN_HORSE
                 
       ***********
       * HORSE 1 *
       ***********
       k1++
       IF k1 > LEN (Horse1)
          k1 = 1
       ENDIF               
 
       pos_x1 = pos_x1 + 10
       IF pos_x1 > (SCR_WIDTH + Horse1 [k1, SPRITE_WIDTH])
          pos_x1 := - Horse1 [k1, SPRITE_WIDTH]
       ENDIF
              
       Anim_Pict [1] = Horse1 [k1]
       *Anim_Pict [1] := ACLONE (Horse1 [k1])
       Anim_Pict [1, SPRITE_X] := pos_x1 
       
       
       ***********
       * Horse 2 *
       ***********  
       k2++
       IF k2 > LEN (Horse2)
          k2 = 1
       ENDIF        

       Anim_Pict [2] = Horse2 [k2]
       *Anim_Pict [2] := ACLONE (Horse3 [k2])


       ***********
       * HORSE 3 *
       ***********
       k3++
       IF k3 > LEN (Horse3)
          k3 = 1
       ENDIF        
       
       pos_x3 = pos_x3 + 8
       IF pos_x3 > (SCR_WIDTH + Horse3 [k3, SPRITE_WIDTH])
          pos_x3 := - Horse3 [k3, SPRITE_WIDTH]
       ENDIF
          
       Anim_Pict [3] = Horse3 [k3]
       *Anim_Pict [3] := ACLONE (Horse3 [k3])
       Anim_Pict [3, SPRITE_X] := pos_x3

       
       ***********
       * Jinete *
       ***********
       k4++
       IF k4 > LEN (Jinete)
          k4 = 1
       ENDIF        
       
       pos_x4 = pos_x4 + 6
       IF pos_x4 > (SCR_WIDTH + Jinete [k4, SPRITE_WIDTH])
          pos_x4 := - Jinete [k4, SPRITE_WIDTH]
       ENDIF
          
       Anim_Pict [4] = Jinete [k4]
       *Anim_Pict [4] := ACLONE (Jinete [k4])
       Anim_Pict [4, SPRITE_X] := pos_x4


       ***********
       * Eagle *
       ***********
       k5++
       IF k5 > LEN (Eagle)
          k5 = 1
       ENDIF        
                 
       pos_x5 = pos_x5 - 6
       IF pos_x5 < - Eagle [k5, SPRITE_WIDTH]
          pos_x5 := SCR_WIDTH + Eagle [k5, SPRITE_WIDTH]
       ENDIF

       Anim_Pict [5] = Eagle [k5]
       *Anim_Pict [5] := ACLONE (Eagle [k5])
       Anim_Pict [5, SPRITE_X] := pos_x5
      

       * Ordena en forma CRECIENTE los SPRITES por la coordenada Z, para representarlos
       * en la profundidad adecuada, esto solo es necesario si existe mas de un objeto animado en la escena
       ASORT (Anim_Pict,,,{|a1,a2| a1[SPRITE_Z] < a2[SPRITE_Z]})

                     
       j = j + 5
       IF j > Background_WIDTH
          j = 0
       ENDIF   
       
       IF j + SCR_WIDTH <= Background_WIDTH
          BMP_COPY_BITBLT (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, Background_hBITMAP, j, 69)
       ELSE
          ancho = Background_WIDTH - j
          BMP_COPY_BITBLT (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, Background_hBITMAP, j, 69)
          BMP_COPY_BITBLT (Memory_Buffer_hBITMAP, ancho, 0, SCR_WIDTH, SCR_HEIGHT, Background_hBITMAP, 0, 69)
       ENDIF
          
       
       FOR i = 1 TO LEN (Anim_Pict)           
           BMP_COPY_TRANSPARENTBLT (Memory_Buffer_hBITMAP, Anim_Pict [i, SPRITE_X], Anim_Pict [i, SPRITE_Y],; 
                                    Anim_Pict [i, SPRITE_WIDTH], Anim_Pict [i, SPRITE_HEIGHT],; 
                                    Anim_Pict [i, SPRITE_hBITMAP], 0, 0,;
                                    Anim_Pict [i, SPRITE_WIDTH], Anim_Pict [i, SPRITE_HEIGHT],;       
                                    ArrayRGB_TO_COLORREF (Anim_Pict [i, SPRITE_TRANSP]), BMP_STRETCH)
       NEXT
       
       IF Black_and_White = .T.       
          BMP_GRAY (Memory_Buffer_hBITMAP, (SCR_WIDTH/3), 0, (SCR_WIDTH/3), SCR_HEIGHT, BMP_GRAY_FULL)
       ENDIF
       BMP_SHOW (hWND, 0, 0, SCR_WIDTH, SCR_HEIGHT, Memory_Buffer_hBITMAP, BMP_COPY)
Return


***********************************************************************************************************************
Function CLICK_SPRITE
        
    MousePos := WIN_GETCURSOR_POS (hWND)

    
    IF Flag_Run = .F.
       Return
    ENDIF
    
    * Ordena en forma DECRECIENTE los SPRITES por la coordenada Z, 
    * esto solo es necesario si existe mas de un objeto animado en la escena
    ASORT (Anim_Pict,,,{|a1,a2| a1[SPRITE_Z] > a2[SPRITE_Z]})
    
        
    FOR i = 1 TO LEN (Anim_Pict)       
       IF BMP_ISPOINT_IN_SPRITE (MousePos[1], MousePos[2], Anim_Pict[i,SPRITE_hBITMAP], Anim_Pict[i,SPRITE_X], Anim_Pict[i,SPRITE_Y], Anim_Pict[i,SPRITE_WIDTH], Anim_Pict[i,SPRITE_HEIGHT], ArrayRGB_TO_COLORREF(Anim_Pict[i,SPRITE_TRANSP]), BMP_TRANSPARENT)
               Nro := Anim_Pict [i, SPRITE_NRO]
               DO CASE
                  CASE Nro < 200
                       MsgInfo ("Click Horse1: Gray")               
                  CASE Nro < 300
                     MsgInfo ("Click Horse2: Black")
                  CASE Nro < 400
                     MsgInfo ("Click Horse3: Brown")
                  CASE Nro < 500   
                     MsgInfo ("Click Jinete")
                  CASE Nro < 600   
                     MsgInfo ("Click Eagle")   
               ENDCASE         
               Return Nro
        ENDIF    
    NEXT
    
Return 0    


