
***************************************************************************************************
* PROGRAMA:	Air Fire
* LENGUAJE:     HMG
* FECHA:	JUNIO 2010
* AUTOR:	Dr. CLAUDIO SOTO
* PAIS:		URUGUAY
* E-MAIL:	srvet@adinet.com.uy
***************************************************************************************************


#include "minigui.ch" 
#include "..\BITMAP_ext.CH"

Function Main 

     
#define SPRITE_hBITMAP 1
#define SPRITE_NRO     2
#define SPRITE_X       3
#define SPRITE_Y       4
#define SPRITE_Z       5
#define SPRITE_WIDTH   6
#define SPRITE_HEIGHT  7    
#define SPRITE_TRANSP  8


PRIVATE hWND      := 0
PRIVATE Avion     := {}
PRIVATE Avion1    := {0,0,0,0,0,0,0,0}
PRIVATE Avion2    := {0,0,0,0,0,0,0,0}
PRIVATE Bateria   := {0,0,0,0,0,0,0,0}
PRIVATE Bala      := {0,0,0,0,0,0,0,0}
PRIVATE Explocion := {0,0,0,0,0,0,0,0}


PRIVATE Background_hBITMAP := 0
PRIVATE Memory_Buffer_hBITMAP := 0

PRIVATE Background_FILE := "Fondo.bmp"
PRIVATE Pictures_FILE1  := "Avion_Uno.bmp"
PRIVATE Pictures_FILE2  := "Avion_Dos.bmp"
PRIVATE Pictures_FILE3  := "Bateria.bmp"
PRIVATE Pictures_FILE4  := "Bala.bmp"
PRIVATE Pictures_FILE5  := "Explota.bmp"


PRIVATE Sound_FILE1      := "Tiro_Tanque.mp3"
PRIVATE Sound_FILE2      := "Explocion.mp3"


PRIVATE pos_x1, pos_x2, pos_x3, pos_y3
PRIVATE flag_Fire      := .F.
PRIVATE flag_Retroceso := .F.
PRIVATE flag_mov_bala  := .F. 
PRIVATE flag_impacto   := .F.

PRIVATE flag_Freeze := .F.

PRIVATE SCR_WIDTH  := 700
PRIVATE SCR_HEIGHT := 360


    DEFINE WINDOW Form_1; 
        AT 0,0; 
        WIDTH 730; 
        HEIGHT 550; 
        TITLE 'Air Fire';
        NOMAXIMIZE;
        NOSIZE; 
        MAIN;
        ON RELEASE Release_Handle ()   
        
                
        @ 10,10 IMAGE Image_1 PICTURE "" WIDTH 0 HEIGHT 0  ONCLICK MOV_BATERIA () 
           
        @ 0,0 PLAYER Sound_1 WIDTH 0 HEIGHT 0 FILE "" NOAUTOSIZEWINDOW NOAUTOSIZEMOVIE NOERRORDLG NOMENU NOPLAYBAR NOOPEN 
        @ 0,0 PLAYER Sound_2 WIDTH 0 HEIGHT 0 FILE "" NOAUTOSIZEWINDOW NOAUTOSIZEMOVIE NOERRORDLG NOMENU NOPLAYBAR NOOPEN
                     
        CREATE_ANIM ()
        
        DEFINE TIMER Timer_1 OF Form_1 INTERVAL 100 ACTION RUN_ANIM ()
        
        @ 450, 300 BUTTON Button_Fire   CAPTION "Fire"    ACTION FIRE ()           
        @ 450, 50  BUTTON Button_Pause  CAPTION "Freeze"  ACTION {|| flag_Freeze := .NOT. (flag_Freeze), Form_1.Button_Pause.Caption := IF(flag_Freeze, "Resume","Freeze")}
        
        @ 400, 100 LABEL Label_1 VALUE "Click in image Background:  Move the antiaircraft battery" AUTOSIZE FONTCOLOR RED BOLD
        
        @ 400, 460 LABEL Label_2 VALUE "Low Level"  AUTOSIZE BOLD
        @ 400, 600 LABEL Label_3 VALUE "High Level" AUTOSIZE BOLD
        @ 420, 500 SLIDER Slider_Level RANGE 10, 90 VALUE 50 

    END WINDOW 
    

    CENTER WINDOW Form_1

    ACTIVATE WINDOW Form_1
        
Return



**************************************************************************************************************
Procedure RELEASE_HANDLE 
    
    Form_1.Sound_1.Stop
    Form_1.Sound_1.Close

    Form_1.Sound_2.Stop
    Form_1.Sound_2.Close
    
    BMP_RELEASE (Avion1 [SPRITE_hBITMAP])        
    BMP_RELEASE (Avion2 [SPRITE_hBITMAP])
    BMP_RELEASE (Bateria [SPRITE_hBITMAP])            
    BMP_RELEASE (Bala [SPRITE_hBITMAP])
    BMP_RELEASE (Explocion [SPRITE_hBITMAP])    
    
    BMP_RELEASE (Background_hBITMAP)
    
    *BMP_RELEASE (Memory_Buffer_hBITMAP) // No es necesario liberar este handle aqui, es liberado por el Control IMAGE de HMG
                                         // al cerrar la ventana Form_1 con ON RELEASE
    
Return



**************************************************************************************************************
Procedure CREATE_ANIM
   
   Memory_Buffer_hBITMAP := BMP_CREATE (SCR_WIDTH, SCR_HEIGHT)

   Background_hBITMAP := BMP_LOAD_FILE (Background_FILE)
  
   Avion1 [SPRITE_hBITMAP]:= BMP_LOAD_FILE (Pictures_FILE1)           
   Avion1 [SPRITE_NRO]    := 100
   Avion1 [SPRITE_X]      := 120
   Avion1 [SPRITE_Y]      := 20
   Avion1 [SPRITE_Z]      := 100
   Avion1 [SPRITE_WIDTH]  := BMP_GET_INFO  (Avion1 [SPRITE_hBITMAP], BMP_INFO_WIDTH)
   Avion1 [SPRITE_HEIGHT] := BMP_GET_INFO  (Avion1 [SPRITE_hBITMAP], BMP_INFO_HEIGHT)
   Avion1 [SPRITE_TRANSP] := BMP_GET_PIXEL (Avion1 [SPRITE_hBITMAP], 0, 0)
           
   
   Avion2 [SPRITE_hBITMAP]:= BMP_LOAD_FILE (Pictures_FILE2)           
   Avion2 [SPRITE_NRO]    := 200
   Avion2 [SPRITE_X]      := 120
   Avion2 [SPRITE_Y]      := 20
   Avion2 [SPRITE_Z]      := 50
   Avion2 [SPRITE_WIDTH]  := BMP_GET_INFO  (Avion2 [SPRITE_hBITMAP], BMP_INFO_WIDTH)
   Avion2 [SPRITE_HEIGHT] := BMP_GET_INFO  (Avion2 [SPRITE_hBITMAP], BMP_INFO_HEIGHT)
   Avion2 [SPRITE_TRANSP] := BMP_GET_PIXEL (Avion2 [SPRITE_hBITMAP], 0, 0)
          

   Bateria [SPRITE_hBITMAP]:= BMP_LOAD_FILE (Pictures_FILE3)           
   Bateria [SPRITE_NRO]    := 200
   Bateria [SPRITE_X]      := 120
   Bateria [SPRITE_Y]      := 290
   Bateria [SPRITE_Z]      := 50
   Bateria [SPRITE_WIDTH]  := BMP_GET_INFO  (Bateria [SPRITE_hBITMAP], BMP_INFO_WIDTH)
   Bateria [SPRITE_HEIGHT] := BMP_GET_INFO  (Bateria [SPRITE_hBITMAP], BMP_INFO_HEIGHT)
   Bateria [SPRITE_TRANSP] := BMP_GET_PIXEL (Bateria [SPRITE_hBITMAP], 0, 0)
   
   Bala [SPRITE_hBITMAP]:= BMP_LOAD_FILE (Pictures_FILE4)           
   Bala [SPRITE_NRO]    := 200
   Bala [SPRITE_X]      := 120
   Bala [SPRITE_Y]      := 290
   Bala [SPRITE_Z]      := 50
   Bala [SPRITE_WIDTH]  := BMP_GET_INFO  (Bala [SPRITE_hBITMAP], BMP_INFO_WIDTH)
   Bala [SPRITE_HEIGHT] := BMP_GET_INFO  (Bala [SPRITE_hBITMAP], BMP_INFO_HEIGHT)
   Bala [SPRITE_TRANSP] := BMP_GET_PIXEL (Bala [SPRITE_hBITMAP], 0, 0)
   
   
   Explocion [SPRITE_hBITMAP]:= BMP_LOAD_FILE (Pictures_FILE5)           
   Explocion [SPRITE_NRO]    := 200
   Explocion [SPRITE_X]      := 120
   Explocion [SPRITE_Y]      := 290
   Explocion [SPRITE_Z]      := 50
   Explocion [SPRITE_WIDTH]  := BMP_GET_INFO  (Explocion [SPRITE_hBITMAP], BMP_INFO_WIDTH)
   Explocion [SPRITE_HEIGHT] := BMP_GET_INFO  (Explocion [SPRITE_hBITMAP], BMP_INFO_HEIGHT)
   Explocion [SPRITE_TRANSP] := BMP_GET_PIXEL (Explocion [SPRITE_hBITMAP], 0, 0)
   
   
   Avion := Avion2
   pos_x1 := SCR_WIDTH + Avion1 [SPRITE_WIDTH]
   pos_x2 := 300
   
   hWND := IMAGE_GET_hWND  ("Form_1","Image_1")
   
   BMP_COPY_BITBLT (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, Background_hBITMAP, 0, 0)
   
   IMAGE_SET_hBITMAP  ("Form_1", "Image_1", Memory_Buffer_hBITMAP, BMP_GET_INFO (Memory_Buffer_hBITMAP, BMP_INFO_WIDTH), BMP_GET_INFO (Memory_Buffer_hBITMAP, BMP_INFO_HEIGHT))
   
   Form_1.Sound_1.Open (Sound_FILE1)
   Form_1.Sound_2.Open (Sound_FILE2)                              
            
Return



Procedure FIRE
   flag_Fire := .T.
   Form_1.Sound_1.Play
Return



Procedure RUN_ANIM
Static cont := 1
                              
       BMP_COPY_BITBLT (Memory_Buffer_hBITMAP, 0, 0, SCR_WIDTH, SCR_HEIGHT, Background_hBITMAP, 0, 0)
              
       *********
       * AVION *
       *********

       IF flag_Freeze = .F.         
          pos_x1 := pos_x1 - 10
          IF pos_x1 < - Avion1 [SPRITE_WIDTH]
             pos_x1 := SCR_WIDTH + Avion1 [SPRITE_WIDTH]
          ENDIF
     
          cont++
       
          IF cont > 5
             cont := 1  
             IF RANDOM (100) < Form_1.Slider_Level.Value
                Avion := Avion1
             ELSE   
                Avion := Avion2
             ENDIF
          ENDIF
         
          Avion [SPRITE_X] := pos_x1
       ENDIF       

       
       BMP_COPY_TRANSPARENTBLT (Memory_Buffer_hBITMAP, Avion [SPRITE_X], Avion [SPRITE_Y],; 
                                    Avion [SPRITE_WIDTH], Avion [SPRITE_HEIGHT],; 
                                    Avion [SPRITE_hBITMAP], 0, 0,;
                                    Avion [SPRITE_WIDTH], Avion [SPRITE_HEIGHT],;       
                                    ArrayRGB_TO_COLORREF (Avion [SPRITE_TRANSP]), BMP_STRETCH)
      
       
       ********
       * TIRO *
       ********
       
       Form_1.Button_Fire.Enabled := .NOT. (flag_Fire) 
       
       IF flag_Fire = .T. .AND. flag_mov_bala = .F.
          flag_mov_bala = .T.
          flag_Retroceso = .T.
          pos_x3 := pos_x2 + 25
          pos_y3 := SCR_HEIGHT - 80
       ENDIF


       IF flag_Fire = .T. .AND. flag_mov_bala = .T.              
          IF Check_Impact () = .F.
             pos_y3 := pos_y3 - 20
          ENDIF   
                    
          IF pos_y3 < 0
              flag_Fire = .F.
              flag_mov_bala = .F.
              Form_1.Sound_1.Stop
              Form_1.Sound_1.Position := 0
          ELSE    
              Bala [SPRITE_X] := pos_x3
              Bala [SPRITE_Y] := pos_y3
              BMP_COPY_TRANSPARENTBLT (Memory_Buffer_hBITMAP, Bala [SPRITE_X], Bala [SPRITE_Y],; 
                                       Bala [SPRITE_WIDTH],  Bala [SPRITE_HEIGHT],; 
                                       Bala [SPRITE_hBITMAP], 0, 0,;
                                       Bala [SPRITE_WIDTH], Bala [SPRITE_HEIGHT],;       
                                       ArrayRGB_TO_COLORREF (Bala [SPRITE_TRANSP]), BMP_STRETCH)
          ENDIF                          
       ENDIF
       

       
       *********************
       * BATERIA ANTIAEREA *
       *********************

       IF flag_Retroceso = .T.
          Bateria [SPRITE_Y] = 305
          flag_Retroceso = .F.
       ELSE
          Bateria [SPRITE_Y] = 290
       ENDIF
       
       
       Bateria [SPRITE_X] := pos_x2
       BMP_COPY_TRANSPARENTBLT (Memory_Buffer_hBITMAP, Bateria [SPRITE_X], Bateria [SPRITE_Y],; 
                                    Bateria [SPRITE_WIDTH]*0.6, Bateria [SPRITE_HEIGHT]*0.6,; 
                                    Bateria [SPRITE_hBITMAP], 0, 0,;
                                    Bateria [SPRITE_WIDTH], Bateria [SPRITE_HEIGHT],;       
                                    ArrayRGB_TO_COLORREF (Bateria [SPRITE_TRANSP]), BMP_STRETCH)
       
       *************
       * EXPLOCION *
       *************
      
       IF flag_Impacto = .T.
          Flag_Impacto = .F.

          Explocion [SPRITE_X] := Bala [SPRITE_X] - 70
          Explocion [SPRITE_Y] := Bala [SPRITE_Y] - 70 

          BMP_COPY_TRANSPARENTBLT (Memory_Buffer_hBITMAP, Explocion [SPRITE_X], Explocion [SPRITE_Y],; 
                                    Explocion [SPRITE_WIDTH], Explocion [SPRITE_HEIGHT],; 
                                    Explocion [SPRITE_hBITMAP], 0, 0,;
                                    Explocion [SPRITE_WIDTH], Explocion [SPRITE_HEIGHT],;       
                                    ArrayRGB_TO_COLORREF (Explocion [SPRITE_TRANSP]), BMP_STRETCH)

          BMP_SHOW (hWND, 0, 0, SCR_WIDTH, SCR_HEIGHT, Memory_Buffer_hBITMAP, BMP_COPY)
          Form_1.Timer_1.Enabled := .F.
          SYS_DELAY_WITH_DOEVENTS (500)
          Form_1.Timer_1.Enabled := .T.
       ELSE
          BMP_SHOW (hWND, 0, 0, SCR_WIDTH, SCR_HEIGHT, Memory_Buffer_hBITMAP, BMP_COPY)
       ENDIF       
Return



Procedure MOV_BATERIA
     MousePos := WIN_GETCURSOR_POS (hWND)
     
     IF (MousePos[1] > 0 .AND. MousePos[1] < SCR_WIDTH) 
         pos_x2 := MousePos[1] - (Bateria [SPRITE_WIDTH]*0.6)/2
         
         IF pos_x2 + (Bateria [SPRITE_WIDTH]*0.6) > SCR_WIDTH
            pos_x2 := SCR_WIDTH - (Bateria [SPRITE_WIDTH]*0.6)
         ENDIF
         
         IF pos_x2 - (Bateria [SPRITE_WIDTH]*0.6) < 0
            pos_x2 := 0
         ENDIF
     ENDIF  
Return



Function Check_Impact
   IF Avion [SPRITE_Z] = Bala [SPRITE_Z]                  
      Bala [SPRITE_X] := pos_x3
      Bala [SPRITE_Y] := pos_y3
          
      *IF BMP_ISPOINT_IN_SPRITE (Bala [SPRITE_X], Bala [SPRITE_Y], Avion [SPRITE_hBITMAP], Avion [SPRITE_X], Avion [SPRITE_Y], Avion [SPRITE_WIDTH], Avion [SPRITE_HEIGHT], ArrayRGB_TO_COLORREF(Avion [SPRITE_TRANSP]), BMP_TRANSPARENT)       
       
  
      IF BMP_IS_INTERSECT_SPRITE (Avion [SPRITE_hBITMAP], Avion [SPRITE_X], Avion [SPRITE_Y],; 
                                   Avion [SPRITE_WIDTH], Avion [SPRITE_HEIGHT],; 
                                   ArrayRGB_TO_COLORREF(Avion [SPRITE_TRANSP]),;
                                   Bala [SPRITE_hBITMAP], Bala [SPRITE_X], Bala [SPRITE_Y],;
                                   Bala [SPRITE_WIDTH], Bala [SPRITE_HEIGHT],;       
                                   ArrayRGB_TO_COLORREF (Bala [SPRITE_TRANSP]),;
                                   BMP_TRANSPARENT)
          
          IF flag_Freeze = .F.               
             pos_x1 := SCR_WIDTH + Avion1 [SPRITE_WIDTH]
          ENDIF
             
          pos_y3 := -1
            
          Form_1.Sound_1.Stop
          Form_1.Sound_1.Position := 0
      
          Form_1.Sound_2.Stop
          Form_1.Sound_2.Position := 0
          Form_1.Sound_2.Play
            
          flag_impacto := .T.
          Return .T.      
      ENDIF
   ENDIF       
Return .F.


