
***************************************************************************************************
* PROGRAMA:	Move Dog
* LENGUAJE:     HMG
* FECHA:	JUNIO 2010
* AUTOR:	Dr. CLAUDIO SOTO
* PAIS:		URUGUAY
* E-MAIL:	srvet@adinet.com.uy
***************************************************************************************************


#include "minigui.ch" 
#include "..\BITMAP_ext.CH"


Function Main 

#define SPRITE_hBITMAP 1
#define SPRITE_WIDTH   2
#define SPRITE_HEIGHT  3    


PRIVATE Dog1 := {}
PRIVATE Dog2 := {}

PRIVATE Pictures_FILE1 := "DOG1.bmp"
PRIVATE Pictures_FILE2 := "DOG2.bmp"


    DEFINE WINDOW Form_1; 
        AT 0,0; 
        WIDTH 290; 
        HEIGHT 300;  
        TITLE 'Move Dog';
        NOMAXIMIZE;
        NOSIZE;  
        MAIN;
        ON RELEASE Release_Handle ()
                 
        @ 30,  30 IMAGE Image_1 PICTURE "" WIDTH 0 HEIGHT 0 
        @ 30, 160 IMAGE Image_2 PICTURE "" WIDTH 0 HEIGHT 0
        
        @ 150,  20 BUTTON Button_1 CAPTION "<<" ACTION {|| Form_1.Timer_1.Enabled := .F., RUN_ANIM (-1)}
        @ 150, 150 BUTTON Button_2 CAPTION ">>" ACTION {|| Form_1.Timer_1.Enabled := .F., RUN_ANIM (+1)}

        @ 200,  80 BUTTON Button_3 CAPTION "Automatic" ACTION {|| Form_1.Timer_1.Enabled := .T.}
        
        DEFINE TIMER Timer_1 OF Form_1 INTERVAL 100 ACTION RUN_ANIM (+1)
        Form_1.Timer_1.Enabled := .F.
        
        Init_Anim ()
                
    END WINDOW 

    CENTER WINDOW Form_1

    ACTIVATE WINDOW Form_1
        
Return



Procedure Release_Handle
    FOR i = 1 TO LEN (Dog1)
        BMP_RELEASE (Dog1 [i, SPRITE_hBITMAP])        
    NEXT    
    FOR i = 1 TO LEN (Dog2)
        BMP_RELEASE (Dog2 [i, SPRITE_hBITMAP])        
    NEXT
Return



Procedure Init_Anim
   #define NRO_PICT_HORIZ 6
   #define NRO_PICT_VERT  4   
   
   #define SPT_WIDTH 64
   #define SPT_HEIGHT 64

   Pictures_hBITMAP   := BMP_LOAD_FILE (Pictures_FILE1)
   k = 0
   Dog1 := {}
   FOR i = 1 TO NRO_PICT_VERT
       FOR j = 1 TO NRO_PICT_HORIZ
           y = (i - 1) * SPT_HEIGHT
           x = (j - 1) * SPT_WIDTH
           aadd (Dog1,{0,0,0})
           k++            
           Dog1 [k, SPRITE_hBITMAP]:= BMP_GET_SPRITE (Pictures_hBITMAP, x, y, SPT_WIDTH, SPT_HEIGHT)           
          
           Dog1 [k, SPRITE_WIDTH]  := BMP_GET_INFO  (Dog1 [k, SPRITE_hBITMAP], BMP_INFO_WIDTH)
           Dog1 [k, SPRITE_HEIGHT] := BMP_GET_INFO  (Dog1 [k, SPRITE_hBITMAP], BMP_INFO_HEIGHT)                    
       NEXT
   NEXT        
   BMP_RELEASE (Pictures_hBITMAP)


   Pictures_hBITMAP   := BMP_LOAD_FILE (Pictures_FILE2)
   k = 0
   Dog2 := {}
   FOR i = 1 TO NRO_PICT_VERT
       FOR j = 1 TO NRO_PICT_HORIZ
           y = (i - 1) * SPT_HEIGHT
           x = (j - 1) * SPT_WIDTH
           aadd (Dog2,{0,0,0,0})
           k++            
           Dog2 [k, SPRITE_hBITMAP]:= BMP_GET_SPRITE (Pictures_hBITMAP, x, y, SPT_WIDTH, SPT_HEIGHT)           
          
           Dog2 [k, SPRITE_WIDTH]  := BMP_GET_INFO  (Dog2 [k, SPRITE_hBITMAP], BMP_INFO_WIDTH)
           Dog2 [k, SPRITE_HEIGHT] := BMP_GET_INFO  (Dog2 [k, SPRITE_hBITMAP], BMP_INFO_HEIGHT)          
       NEXT
   NEXT        
   BMP_RELEASE (Pictures_hBITMAP)
   
   IMAGE_SET_hBITMAP  ("Form_1", "Image_1", Dog1 [1,SPRITE_hBITMAP], Dog1 [1,SPRITE_WIDTH], Dog1 [1,SPRITE_HEIGHT])
   IMAGE_SET_hBITMAP  ("Form_1", "Image_2", Dog2 [1,SPRITE_hBITMAP], Dog2 [1,SPRITE_WIDTH], Dog2 [1,SPRITE_HEIGHT])   
Return



Procedure RUN_ANIM (mov)
Static n:= 1

       n = n + mov
       
       IF n > 24
          n = 1
       ENDIF
       
       IF n < 1
          n = 24
       ENDIF
       
       IMAGE_SET_hBITMAP  ("Form_1", "Image_1", Dog1 [n,SPRITE_hBITMAP], Dog1 [n,SPRITE_WIDTH], Dog1 [n,SPRITE_HEIGHT])
       IMAGE_SET_hBITMAP  ("Form_1", "Image_2", Dog2 [n,SPRITE_hBITMAP], Dog2 [n,SPRITE_WIDTH], Dog2 [n,SPRITE_HEIGHT])            
Return

